#region Using Statements
using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
#endregion


namespace HeHathNoFury
{
    /// <summary>
    /// This is a game component that implements the common enemy in the game
    /// </summary>
    public class enemy : Microsoft.Xna.Framework.DrawableGameComponent
    {
        protected Texture2D Enemy;
        protected Rectangle eRect;
        protected Vector2 epos;
        protected int Yspeed;
        protected int Xspeed;
        protected Random random;

        protected Rectangle sBounds;

        // width and height of enemy
        protected const int ewidth = 42;
        protected const int eheight = 42;

        public enemy (Game game, ref Texture2D tEnemy)
            : base(game)
        {
            Enemy = tEnemy;
            epos = new Vector2();

            eRect = new Rectangle(0, 0, ewidth, eheight);

#if XBOX360
            sBounds = new Rectangle((int)(Game.Window.ClientBounds.Width * 0.03f),
                (int)(Game.Window.ClientBounds.Height * 0.03f), Game.Window.ClientBounds.Width-(int)(Game.Window.ClientBounds.Width * 0.03f),
                Game.Window.ClientBounds.Height - (int)(Game.Window.ClientBounds.Height * 0.03f));
#else
            sBounds = new Rectangle(0, 0, Game.Window.ClientBounds.Width, game.Window.ClientBounds.Height);
#endif

            // initialize random number generator, put meteor in start position
            random = new Random(this.GetHashCode());
            StartPosition();
        }

        // initialize enemy location and velocity
        protected void StartPosition()
        {
            epos.X = Game.Window.ClientBounds.Width - ewidth;
            epos.Y = random.Next(Game.Window.ClientBounds.Height-eheight);
            Xspeed = random.Next(4)-1;
        }

        /// <summary>
        /// Allows the game component to perform any initialization it needs to before starting
        /// to run.  This is where it can query for any required services and load content.
        /// </summary>
        public override void Initialize()
        {
            // TODO: Add your initialization code here

            base.Initialize();
        }

        /// <summary>
        /// Allows the game component to update itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public override void Update(GameTime gameTime)
        {
            // if enemy is still visible
            if (((epos.Y <= Game.Window.ClientBounds.Height - 3 * eheight) && (epos.Y <= Game.Window.ClientBounds.Height)) && (epos.X >= 0) && (epos.X <= Game.Window.ClientBounds.Width))
            {
                StartPosition();
            }

            // move enemy
            epos.Y += Yspeed;
            epos.X -= Xspeed;

            // keep enemy on floor
            
            if (epos.X > sBounds.Width - ewidth)
            {
                epos.X = sBounds.Width - ewidth;
                Xspeed = -Xspeed;
            }
            if (epos.Y < sBounds.Height - 3*eheight)
            {
                epos.Y = sBounds.Height - 3*eheight;
                Yspeed = -Yspeed;
            }
            if (epos.Y > sBounds.Height - eheight)
            {
                epos.Y = sBounds.Height - eheight;
                Yspeed = -Yspeed;
            }

            base.Update(gameTime);
        }

        // allows game component to draw content in game screen
        public override void Draw(GameTime gameTime)
        {
            // get current sprite batch
            SpriteBatch sBatch = (SpriteBatch) Game.Services.GetService(typeof(SpriteBatch));

            // draw enemy
            sBatch.Draw(Enemy, epos, eRect, Color.White);

            base.Draw(gameTime);
        }
        
        // check for collision, return if true
        public bool CheckCollision(Rectangle rect)
        {
            Rectangle srect = new Rectangle((int)epos.X, (int)epos.Y, ewidth, eheight);

            return srect.Intersects(rect);
        }
    }
}